=== debian/changelog ===
supertux (0.6.3-4) unstable; urgency=medium

  * Fix FTBFS with cmake 4. (Closes: #1113549)
  * Bump Standards-Version to 4.7.2.

 -- Vincent Cheng <vcheng@debian.org>  Fri, 26 Sep 2025 19:27:25 -0700

supertux (0.6.3-3) unstable; urgency=medium

  [ Patrice Duroux ]
  * Improve d/watch file. (Closes: #1038393)

  [ Vincent Cheng ]
  * Update obsolete build-deps flagged by lintian.
  * Bump Standards-Version to 4.7.0.

 -- Vincent Cheng <vcheng@debian.org>  Sat, 30 Nov 2024 20:20:04 -0800

supertux (0.6.3-2) unstable; urgency=medium

  * Team upload.
  * Import patch to fix FTBFS with gcc 12. (Closes: #1013045)
  * Bump Standards-Version to 4.6.1.
  * Fix additional spelling errors found by lintian.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 30 Jul 2022 15:34:43 +0200

supertux (0.6.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release. (Closes: #1005373)
  * Refresh patches.
  * Update watch file to match source tarball.
  * Symlink fonts available as packages.
  * Add missing build dependencies: libfribidi-dev, libglm-dev,
    libharfbuzz-dev, zlib1g-dev.
  * Make sure that system physfs is used for building.
  * Build with BUILD_RPATH_USE_ORIGIN to use relative build paths
    This fixes reproducibility with varying paths.
  * Bump Standards-Version to 4.6.0.
  * Update copyrights.

 -- Reiner Herrmann <reiner@reiner-h.de>  Mon, 21 Feb 2022 22:27:05 +0100
